package com.inet.ailink.receiver.common.response;

import com.inet.ailink.receiver.common.enums.StatusCode;

//@ApiModel("基础响应参数")
//@JsonInclude(JsonInclude.Include.NON_NULL)
public class Response<T> {
    private String code;
    private String msg;
    private T data;
   

    public Response() {
        this(StatusCode.SUCCESS);
    }

    public void setData(T data) {
        this.data = data;
    }

    public Response(StatusCode errorEnum) {
        setErr(errorEnum);
    }

    public Response(StatusCode err, T data) {
        setErr(err);
        setData(data);
    }

    public void setErr(StatusCode error) {
        this.code = error.getCode();
        this.msg = error.getMsg();
    }

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public T getData() {
		return data;
	}
    
    
}
