package com.inet.ailink.receiver.common.utils;

import org.apache.commons.codec.binary.Base64;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.nio.charset.StandardCharsets;

/**
 *  AES 加解密工具类
 */
public class AESUtils {


    /**
     * CBC 密码分组链接模式加密，需要一个向量iv，可增加加密算法的强度
     * @param content 待加密内容
     * @param key 秘钥
     * @param offset 偏移量字符串
     */
    public static String aesCBCEncrypt(String content, String key,String offset) throws Exception {
    	key = convertKey(key);
    	offset = convertOffset(offset);
        Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
        SecretKeySpec secretKeySpec = new SecretKeySpec(key.getBytes(), "AES");
        IvParameterSpec iv = new IvParameterSpec(offset.getBytes());
        cipher.init(Cipher.ENCRYPT_MODE, secretKeySpec, iv);
        byte[] encrypted = cipher.doFinal(content.getBytes(StandardCharsets.UTF_8));
//        return Base64.encodeBase64String(encrypted);
        return Base64Util.encoderString(encrypted);
    }
 
    /**
     * CBC 密码分组链接模式解密
     * @param content 待解密内容
     * @param key 秘钥
     * @param offset 偏移量字符串
     */
    public static String aesCBCDecrypt(String content, String key,String offset) throws Exception {
    	key = convertKey(key);
    	offset = convertOffset(offset);
        Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
        SecretKeySpec secretKeySpec = new SecretKeySpec(key.getBytes(), "AES");
        IvParameterSpec iv = new IvParameterSpec(offset.getBytes());
        cipher.init(Cipher.DECRYPT_MODE, secretKeySpec, iv);
        byte[] encrypted = cipher.doFinal(Base64.decodeBase64(content));
        return new String(encrypted, StandardCharsets.UTF_8);
    }

    public static String convertKey(String key){
    	if(StringSelfUtil.isEmpty(key)){
            throw new NullPointerException();
    	}
        int length = key.length();
        if(length > 16) {
            key = key.substring(0, 16);
        }
    	return key;
    }

    public static String convertOffset(String offset){
    	if(StringSelfUtil.isEmpty(offset)){
    		throw new NullPointerException();
    	}
        int length = offset.length();
        if(length > 16){
            offset = offset.substring(0,16);
        }
    	return offset;
    }
    
    public static void main(String[] args) throws Exception{

    }
 
}
