package com.inet.ailink.receiver.common.utils;

import java.security.MessageDigest;
import java.util.Arrays;
import java.util.Map;
import java.util.Set;


public class MD5Util {
    public MD5Util(){}

    /**
     * 生成签名
     * @param data 待签名数据
     * @param key API密钥
     * @return 签名
     */
    public static String generateSignature(Map<String, Object> data, String key) throws Exception {
        Set<String> keySet = data.keySet();
        String[] keyArray = keySet.toArray(new String[keySet.size()]);
        Arrays.sort(keyArray);
        StringBuilder sb = new StringBuilder();
        for (String k : keyArray) {
        	if(data.get(k) != null){
        		String keyValueTemp = data.get(k).toString().trim();
        		if (keyValueTemp.length() > 0) // 参数值为空，则不参与签名
                    sb.append(k).append("=").append(keyValueTemp).append("&");
        	}
        }
        sb.append("key=").append(key);
        String md5Str = getMD5(sb.toString()).toUpperCase();
        return md5Str;
       
    }

    /**
     * 生成 MD5
     * @param data 待处理数据
     * @return MD5结果
     */
    public static String getMD5(String data) throws Exception {
        MessageDigest md = MessageDigest.getInstance("MD5");
        byte[] array = md.digest(data.getBytes("UTF-8"));
        StringBuilder sb = new StringBuilder();
        for (byte item : array) {
            sb.append(Integer.toHexString((item & 0xFF) | 0x100).substring(1, 3));
        }
        return sb.toString().toUpperCase();
    }
    
    public static void main(String [] args) throws Exception{

    }
}