 package com.inet.ailink.receiver.controller;

import java.io.IOException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.inet.ailink.receiver.common.utils.JsonUtils;
import com.inet.ailink.receiver.service.impl.SysLogsServiceImpl;


@RestController
@RequestMapping(value="deData",produces={"application/json;charset=UTF-8"})
public class DeDataBaseController extends BaseController {
	
	@Autowired
	SysLogsServiceImpl sysLogsServiceImpl;

	/**
	 * 接受4G/WIFI+BLE设备测量结果数据
	 * @param params
	 * @param request
	 * @param response
	 * @throws IOException
	 */
	@RequestMapping(value="pullData")
	@ResponseBody
	public Object saveDataBase(@RequestBody String params,HttpServletRequest request,HttpServletResponse response) throws IOException {
		return   sysLogsServiceImpl.save(params,request);
	}
	
	/**
	 * 获取4G/WIFI+BLE设备测量结果数据
	 * @param date
	 * @param request
	 * @param response
	 * @throws IOException
	 */
	@RequestMapping(value="getData/{date}")
	@ResponseBody
	public String getData(@PathVariable String date,HttpServletRequest request,HttpServletResponse response) throws IOException {
		return JsonUtils.toJson(sysLogsServiceImpl.getData(date)) ;
	}
	
	
}